﻿var cometmarks_local_revision = -1;
var Bookmarks_Changed_Time = "";
var menu_timer = null;
var update_timer = null;
var cometmarks = Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension);
	
var pref_observe =
{
	QueryInterface: function(iid)
	{
		if (!iid.equals(Components.interfaces.nsISupports) && !iid.equals(Components.interfaces.nsIObserver))
			throw Components.results.NS_ERROR_NO_INTERFACE;

		return this;
	}
};

var observer = new function()
{ 
        var observerService; 
        
        var is_registered = false;    
					
				var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
        
        this.init = function()
        { 
        	observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService); 
          this.register(); 
        }; 
        
        this.destroy = function()
        { 
          this.unregister(); 
          observerService = null; 
        }; 
        
        this.observe = function(subject, topic, data)
        { 
					var autosync_interval_sec = get_autosync_interval_sec();// get value from pref.js, default is 5 * 60
        	if (topic == 'cometmarks_update_callback')
        	{
        		window.clearTimeout(menu_timer);
        		menu_timer = null;
        		cometmarks_gdata.gBookmarks_Status = data;
        		var username = cometmarks_gdata.gUserName;
        		var password = cometmarks_gdata.gPassword;
        			
        		if ("OK" == data)
        		{  
							// set local notes
							var cometmarks_notes = cometmarks.GetCometMarksLocalNote();
							var server_notes = cometmarks_get_server_notes();
							cometmarks_notes.SetLocalNotes( server_notes );
							
							var bookmarks_info = cometmarks.GetCometMarksInfo();
							
							cometmarks_merge_special();
							var server_bookmarks_content = bookmarks_info.Bookmarks_Content;
							
							if (server_bookmarks_content == "")
							{
								write_log("update: server bookmarks content is null");
								update_status("OK");
								set_next_sync_time(autosync_interval_sec);
								return;
							}
							
							// set the local revision
							cometmarks_local_revision = bookmarks_info.Bookmarks_Version;
							write_log("current local revision: " + cometmarks_local_revision);
							
							// to check if need to overwrite
							var local_bookmarks_content = cometmarks_access_favorite();
							if (cometmarks.CometmarksEqual(local_bookmarks_content))// equal
							{
								write_log("local and server's bookmarks content are the same");
								update_status("OK");
								set_next_sync_time(autosync_interval_sec);
								return;
							}
							
							cometmarks_gdata.gMerge_Closed_Directly = true;
							cometmarks_overwrite_dialog_show(); // to choose orerwrite method
								
							// close or cancel to exit the overwrite dialog
							if (!cometmarks_gdata.gMerge_Closed_Directly)
							{
								// logout and clear accout's info
								cometmarks.LogOut(); 
								
								var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
								os.notifyObservers(null, "cometmarks-statechange", "COMETMARKS_NOTLOGIN");
								cometmarks_gdata.gBookmarks_Status = "COMETMARKS_NOTLOGIN";
								set_next_sync_time("N/A");
								return;
							}
			        	
			       	if (!cometmarks_gdata.gBookmarks_Changed)// only for overwrite local
			       	{
			       		update_status("OK");
			       		set_next_sync_time(autosync_interval_sec);
			       	}
        		}
        		else if ("EXCEPTION" == data)
        		{
        			update_status("EXCEPTION");
        			write_log("update exception");
        			cometmarks_show_error_message();
        		}
        		else if ("INVALID_PASSWORD" == data)
        		{
        			update_status("INVALID_PASSWORD");
        			write_log("update invalid password");
        		}
        		else if ("OUT_OF_DATE" == data)
        		{
        			update_status("OUT_OF_DATE");
        			write_log("update out of date");
        		}
        		else if ("CONNECT_FAILED" == data)
        		{
        			update_status("CONNECT_FAILED");
        			write_log("update connect failed and begin to re-connect");
        			menu_timer = window.setTimeout(function(){cometmarks_login();}, autosync_interval_sec * 1000);
        		}
        		else if("NO_RECORD" == data)
        		{
        			update_status("NO_RECORD");
        			write_log("update no record");
        			set_next_sync_time(autosync_interval_sec);
        		}
        		else
        		{
        			update_status("NUKNOWN ERROR");
        			write_log("update unknown error");
    					cometmarks_show_error_message();
        		}
           }
            
        	if (topic == 'cometmarks_sync_callback')
        	{       	
        		cometmarks_gdata.gBookmarks_Status = data;
        		if ("OK" == data)
        		{
							// set local notes
							var cometmarks_notes = cometmarks.GetCometMarksLocalNote();
							var server_notes = cometmarks_get_server_notes();
							cometmarks_notes.SetLocalNotes( server_notes );
							
        			var bookmarks_info = cometmarks.GetCometMarksInfo();					

        			cometmarks_merge_special();					
	        		var server_bookmarks_content = bookmarks_info.Bookmarks_Content;
	        		if (server_bookmarks_content == "")
	        		{
	        			update_status("OK");
	        			write_log("sync: server bookmarks content is null");
	        			set_next_sync_time(autosync_interval_sec);
	        			return;
	        		}
	        		
							var server_revision = bookmarks_info.Bookmarks_Version;
							write_log("cometmarks current revision: " + server_revision);

							if (cometmarks_local_revision == server_revision)
							{
								update_status("OK");
								set_next_sync_time(autosync_interval_sec);
								return;
							}
							
							// revision not equal, and compare contents
							var local_bookmarks_content = cometmarks_access_favorite();						
							if (!cometmarks.CometmarksEqual(local_bookmarks_content))// un_equal
	        		{
								cometmarks_recover();
	        			write_log("sync: cometmarks recover completely");
        			}
        			
        			cometmarks_local_revision = server_revision;
        			update_status("OK");// include update version and lastsync_time
        			set_next_sync_time(autosync_interval_sec);    		
        		}
        		else if ("EXCEPTION" == data)
        		{
        			update_status("EXCEPTION");
        			write_log("sync exception");
							cometmarks_show_error_message();
        		}
        		else if ("INVALID_PASSWORD" == data)
        		{
        			update_status("INVALID_PASSWORD");
        			write_log("sync invalid password");
        		}
        		else if ("OUT_OF_DATE" == data)
        		{
        			update_status("OUT_OF_DATE");
        			write_log("sync out of date");
        		}
        		else if ("CONNECT_FAILED" == data)
        		{
        			update_status("CONNECT_FAILED");
        			write_log("sync connect failed and begin to re-connect");
        			set_next_sync_time(autosync_interval_sec);
        		}
        		else if("NO_RECORD" == data)
        		{
        			update_status("NO_RECORD");
        			write_log("sync no record");
        			set_next_sync_time(autosync_interval_sec);
        		}
        		else
        		{
        			write_log("sync unknown error");
        			update_status("NUKNOWN ERROR");
        			cometmarks_show_error_message();
        		}
          }
          
					if (topic == 'cometmarks_overwrite_callback')
					{
						cometmarks_gdata.gBookmarks_Status = data;
        		if ("OK" == data)
        		{
        			var bookmarks_info = cometmarks.GetCometMarksInfo();
        			cometmarks_local_revision = bookmarks_info.Bookmarks_Version;
		        	update_status("OK");
		        	set_next_sync_time(autosync_interval_sec);
        		}
        		else
        		{
        			if ("EXCEPTION" == data)
        				update_status("EXCEPTION");
        			else if ("OUT_OF_DATE" == data)
        				update_status("OUT_OF_DATE");
        			else if ("CONNECT_FAILED" == data)
        				update_status("CONNECT_FAILED");
        			else
        				update_status("NUKNOWN ERROR");
        				
        			// merge faild, exit
        			write_log("cometmarks overwrite failed");
        			set_next_sync_time("N/A");
        			cometmarks.LogOut(); 
        			cometmarks_show_error_message();
        		}
					}
					
					if (topic == 'observer_changed')
					{						
						if (cometmarks_gdata.gObserver_Registered)
						{
							is_registered = false;
							return;
						}
						
						is_registered = true;
						cometmarks_gdata.gObserver_Registered = true;
						observerService.addObserver(this, "cometmarks_update_callback", false);
          	observerService.addObserver(this, "cometmarks_sync_callback", false); 
          	observerService.addObserver(this, "cometmarks_overwrite_callback", false);
          	observerService.addObserver(this, "cometmarks-statechange", false);
          	begin_bookmark_listener();// deal with bookmarks
          	Extension_UninstallObserver.register();// deal with uninstall extension    	
					}	
					
					if (topic == "cometmarks-statechange")
					{
						if ("COMETMARKS_NOTLOGIN" == data)
						{
							window.clearTimeout(menu_timer);
							menu_timer = null;
						}
					}				 
        }; 
        
        this.register = function()
        { 
        	observerService.addObserver(this, "observer_changed", false);
        	
        	if (cometmarks_gdata.gObserver_Registered)
        	{
        		is_registered = false;
        		return;
        	}
        	
        	is_registered = true;
        	cometmarks_gdata.gObserver_Registered = true;
        	observerService.addObserver(this, "cometmarks_update_callback", false);
          observerService.addObserver(this, "cometmarks_sync_callback", false); 
          observerService.addObserver(this, "cometmarks_overwrite_callback", false);
          observerService.addObserver(this, "cometmarks-statechange", false);
					begin_bookmark_listener();
					Extension_UninstallObserver.register();
        }; 
        
        this.unregister = function()
        { 
        	observerService.removeObserver(this, "observer_changed");
        	
        	if (!is_registered)        
        		return;
        		
        	observerService.removeObserver(this, "cometmarks_update_callback");
        	observerService.removeObserver(this, "cometmarks_sync_callback"); 
        	observerService.removeObserver(this, "cometmarks_overwrite_callback");
        	observerService.removeObserver(this, "cometmarks-statechange");
        	end_bookmark_listener();
					Extension_UninstallObserver.unregister();
					
					cometmarks_gdata.gObserver_Registered = false;
       		observerService.notifyObservers(null, "observer_changed", null);
        }; 
}; 

function cometmarks_OnLoad()
{ 							 	 
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");	
	
	if (null == cometmarks)
	{
		write_log("cometmarks Load: cometmarks no instance!");
		return;
	}
	// register observer
	observer.init(); 
		
	setInterval("cometmarks_timetick();", 100);
		
	// to monitor sync in every second
	setInterval("cometmarks_monitor_sync();", 1000);
	
	gBrowser.addProgressListener( urlBarListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT );
	
	document.getElementById("toggle_taskbar").addEventListener("click", check_stastusbar, false);
	
	// do it when open firefox first time
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService); 
	var branch = ps.getBranch("");
	branch.QueryInterface(Components.interfaces.nsIPrefBranch2).addObserver("", pref_observe, false);
	var prefs = ps.getBranch("cometmarks.");
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	if (!cometmarks_gdata.gExtension_Init)
	{		
		// init now
		cometmarks_gdata.gExtension_Init = true;
		
		delete_log();// remove log last time
		
		var file = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('ProfD', Components.interfaces.nsIFile);
		cometmarks.SetPath( file.path );
				
		// get username and password
		var aUsername = "", aPassword = "";
			
		aUsername = prefs.getCharPref("username");
		  
		var username_utf16 = utf8to16(aUsername);
		aUsername = username_utf16;
		aPassword = get_password(aUsername);// get password from loginManager
			
		// save username and password in global data
		cometmarks_gdata.gUserName = aUsername;
		cometmarks_gdata.gPassword = aPassword;
	
		var bookmarks_info = cometmarks.GetCometMarksInfo();
		if (aUsername != "" && aPassword != "")
		{
			var state = bookmarks_info.Current_State;
			if (!bookmarks_info.Loginned && state == "COMETMARKS_IDLE")
			{
				write_log("cometmarks login account: " + aUsername);
				setTimeout(function(){ cometmarks_set_username(aUsername, aPassword); }, 100);
			}
		}
		else
		{
			if (!bookmarks_info.Loginned)
			{
				var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				os.notifyObservers(null, "cometmarks-statechange", "COMETMARKS_NOTLOGIN");
				cometmarks_gdata.gBookmarks_Status = "COMETMARKS_NOTLOGIN";
			}
		}
	
		// to check if the first time install
		if ( !prefs.getBoolPref("first_install") )
			return;
		else	
		{
			prefs.setBoolPref("first_install", false);
			window.open("chrome://cometmarks/content/cometmarks_setting.xul", "CometMarks Setting...", "chrome,titlebar,toolbar,centerscreen");	
		}
	}
}

function cometmarks_OnUnload()
{	
	// remove observer
	observer.destroy();
	
	gBrowser.removeEventListener("load", detect_pageload);
}

function get_last_error()
{
	if (null == cometmarks)	
	{
		write_log( "cometmarks == null" );
		return;
	}
	
	var bookmarks_info = cometmarks.GetCometMarksInfo();
	var message = bookmarks_info.Error.ErrorMessage;
	
	write_log(message);
}

function check_stastusbar(event)
{
	if ( event.target.id != "toggle_taskbar" )
		return;
	
	if ( cometmarks.GetCometMarksInfo().Loginned && document.getElementById("toggle_taskbar").getAttribute("checked") == "true" )
	{
		document.getElementById("cometmarks_showstatusicon_menuitem").setAttribute("disabled", "false");
		document.getElementById("cometmarks_showstatusicon_status").setAttribute("disabled", "false");
		
		if ( document.getElementById("cometmarks_showstatusicon_menuitem").getAttribute("checked") == "true" )
		{
			document.getElementById("cometmarks_button_note").setAttribute("image", "chrome://cometmarks/skin/logo_16.png");
			document.getElementById("cometmarks_button_note").setAttribute("disabled", "false");	
			document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "false");
			document.getElementById("cometmarks_show_note_menuitem").setAttribute("disabled", "false");
		}
		else
		{
			document.getElementById("cometmarks_button_note").setAttribute("image", "chrome://cometmarks/skin/state_not_login_16.png");
			document.getElementById("cometmarks_button_note").setAttribute("disabled", "true");	
			document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "true");
			document.getElementById("cometmarks_show_note_menuitem").setAttribute("disabled", "true");
		}
	}
	else
	{
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel.state == "open" )
		{
			cometmarks_note_panel_doclose(true); // save note and panel data first
			panel.sizeTo(10, 10);
		}
		
		document.getElementById("cometmarks_button_note").setAttribute("image", "chrome://cometmarks/skin/state_not_login_16.png");
		document.getElementById("cometmarks_button_note").setAttribute("disabled", "true");
		
		document.getElementById("cometmarks_showstatusicon_menuitem").setAttribute("disabled", "true");
		document.getElementById("cometmarks_showstatusicon_status").setAttribute("disabled", "true");
		document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "true");
		document.getElementById("cometmarks_show_note_menuitem").setAttribute("disabled", "true");
	}
}

window.addEventListener("load", cometmarks_OnLoad, false);
window.addEventListener("unload", cometmarks_OnUnload, false);