var cometmarks = Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension);
var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
var mainWindow = wm.getMostRecentWindow("navigator:browser");
	
var stateObserver = 
{
	observe: function(subject, topic, data) 
  {
  	if (topic == "cometmarks-statechange")
			sync_statusbar(data);
  }
};

function sync_statusbar(status)
{ 
	var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
	
	// show the username in statusbar
	var aUsername = "";
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefs = ps.getBranch("cometmarks.");
	aUsername = prefs.getCharPref("username");
	
	var state_text = document.getElementById("statusbar_text");
	if (aUsername.length == 0)
		state_text.setAttribute("value", "N/A");
	else
	{
		var username_utf16 = utf8to16(aUsername);
		state_text.setAttribute("value", username_utf16);
	}
	
	var state_image = document.getElementById("statusbar_image");
	if (status == "COMETMARKS_CHANGED")
	{
		show_menubar_state("login");
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_sync_pending_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.wait");
	}
	else if (status == "SYNC_SUCCESS" || status == "COMETMARKS_IDLE")
	{
		show_menubar_state("login");
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_sync_ok_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.success");
		
		// check status if display 
		var hide_statusicon =  prefs.getBoolPref("hidestatusicon");		
		update_statusbar(hide_statusicon);
		
		// get notes data first, and then update notes
		cometmarks_get_local_notes();
		cometmarks_update_notes();
	}
	else if (status == "INVALID_PASSWORD")
	{
		show_menubar_state("logout");
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_error_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.invalid.password");
	}
	else if (status == "OUT_OF_DATE")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_error_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.out.of.date");
	}
	else if (status == "CONNECT_FAILED")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_error_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.connect.failed");
	}
	else if (status == "NO_RECORD")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_sync_ok_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.success");
	}
	else if (status == "COMETMARKS_SYNCING")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_connecting_16.gif");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.syncing");
	}
	else if (status == "COMETMARKS_UPDATING")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_connecting_16.gif");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.updating");
	}
	else if (status == "COMETMARKS_OVERWRITING")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_connecting_16.gif");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.overwriting");
	}
	else if (status == "EXCEPTION")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_error_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.exception");
	}
	else if (status == "UNKNOWN_STATE")
	{
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_error_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.unknown.state");
	}
	else if (status == "COMETMARKS_NOTLOGIN")
	{
		show_menubar_state("logout");
		if (aUsername.length == 0)
			state_text.setAttribute("value", "N/A");
		else
		{
			var username_utf16 = utf8to16(aUsername);
			state_text.setAttribute("value", username_utf16);
		}
		state_image.setAttribute("src", "chrome://cometmarks/skin/state_not_login_16.png");
		state_image.tooltipText = bubble.GetStringFromName("cometmarks.status.no.login");
		
		// close note panel
		var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		os.notifyObservers(null, "cometmarks-notes-state", "close");
		os.notifyObservers(null, "cometmarks-notes-state", "disabled");
	}
}

function On_load()
{
	try
	{	
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        
		var prefs = ps.getBranch("cometmarks.");
    
		var hide_statusicon =  prefs.getBoolPref("hidestatusicon");
			
		update_statusbar(hide_statusicon);
		
		var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    
		os.addObserver(stateObserver, "cometmarks-statechange", false);
		
		os.addObserver(notesObserver, "cometmarks-notes-state", false);
		
		var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
		
		os.notifyObservers(null, "cometmarks-statechange", cometmarks_gdata.gBookmarks_Status);
		
		// to listen panel_note_label
		var panel = document.getElementById("cometmarks_note_panel");
		panel.addEventListener("mousedown", cometmarks_panel_mouseDown, false);
		panel.addEventListener("mouseup", cometmarks_panel_mouseUp, false); 
		panel.addEventListener("mousemove", cometmarks_panel_mouseMove, false);
		panel.addEventListener("mouseout", cometmarks_panel_mouseOut, false);
	} 
	catch(e) 
	{
		write_log(e);
	}	    
}

function cometmarks_toggle_icon()
{
	var state = set_hide_statusicon();
	update_statusbar(state);
}

function set_hide_statusicon()
{
	try
	{
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        
		var prefs = ps.getBranch("cometmarks.");
    
		var hide_statusicon = prefs.getBoolPref("hidestatusicon");
			
		prefs.setBoolPref("hidestatusicon", !hide_statusicon);
    
		return !hide_statusicon;
   
	} 
	catch(e) 
	{
		write_log(e);
	}
}

function update_statusbar(state)
{
	if ( mainWindow.document.getElementById("toggle_taskbar").getAttribute("checked") == "false" )
		return;
		
	if (!state)
	{
		document.getElementById("cometmarks_showstatusicon_status").setAttribute("checked", "true");	
		mainWindow.document.getElementById("cometmarks_showstatusicon_menuitem").setAttribute("checked", "true");			
		
		mainWindow.document.getElementById("cometmarks_button_note").setAttribute("disabled", "false");
		mainWindow.document.getElementById("cometmarks_button_note").setAttribute("image", "chrome://cometmarks/skin/logo_16.png");
		
		mainWindow.document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "false");
		mainWindow.document.getElementById("cometmarks_show_note_menuitem").setAttribute("disabled", "false");
	}	
	else
	{
		document.getElementById("cometmarks_showstatusicon_status").removeAttribute("checked");
		mainWindow.document.getElementById("cometmarks_showstatusicon_menuitem").removeAttribute("checked");		
		
		mainWindow.document.getElementById("cometmarks_button_note").setAttribute("image", "chrome://cometmarks/skin/state_not_login_16.png");
		mainWindow.document.getElementById("cometmarks_button_note").setAttribute("disabled", "true");
		
		mainWindow.document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "true");
		mainWindow.document.getElementById("cometmarks_show_note_menuitem").setAttribute("disabled", "true");
	}
	
	document.getElementById("cometmarks_statusbarpanel").hidden = state;
}

function cometmarks_statusbar_click(event)
{
	// Handle different event models
	var e = event || window.event;
	if ('object' == typeof e)
	{
		var btnCode = e.button;
		switch (btnCode)
		{
			case 0:// left button
				cometmarks_setting();
				break;
        
			case 1:// middle button
			case 2:// right button
			default: 
				break;
		}
	}
}

function Un_load() 
{
	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	os.removeObserver(stateObserver, "cometmarks-statechange");
	os.removeObserver(notesObserver, "cometmarks-notes-state");
	
	// remove
	var panel = document.getElementById("cometmarks_note_panel");
	panel.removeEventListener("mousedown", cometmarks_panel_mouseDown);
	panel.removeEventListener("mouseup", cometmarks_panel_mouseUp); 
	panel.removeEventListener("mousemove", cometmarks_panel_mouseMove);
	panel.removeEventListener("mouseout", cometmarks_panel_mouseOut);
}

////////////////////////////////////////////
// about replace panel
function cometmarks_show_replace_panel()
{
	// open panel
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var mainWindow = wm.getMostRecentWindow("navigator:browser");
	var gBrowser = mainWindow.getBrowser();
	var browser = gBrowser.selectedTab;
	var panel = document.getElementById("cometmarks_replace_panel");

	var pX = browser.boxObject.screenX;
	var full_x = window.innerWidth;
	var window_width = 280;
	if (pX + window_width > full_x)
	{
		panel.openPopup(browser, "after_end", 0, 0, false, false);
	}
	panel.openPopup(browser, "after_start", 0, 0, false, false);
}

function cometmarks_panel_popup()
{
	// init panel
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var mainWindow = wm.getMostRecentWindow("navigator:browser");
	var gBrowser = mainWindow.getBrowser();
	var currentTab = gBrowser.getBrowserAtIndex(gBrowser.mTabContainer.selectedIndex);	 

	document.getElementById("cometmarks_replace_newtitle").value = currentTab.contentTitle;
	document.getElementById("cometmarks_replace_newurl").value = currentTab.currentURI.spec;
	
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	var bookitem_id = bookmarksService.getItemIdForGUID(cometmarks_gdata.gCurrent_Tab_Guid);
	var old_title = bookmarksService.getItemTitle(bookitem_id);
	var old_url = bookmarksService.getBookmarkURI(bookitem_id).spec;
  
	document.getElementById("cometmarks_replace_oldtitle").value = old_title;
	document.getElementById("cometmarks_replace_olrurl").value = old_url;
	
	// set focus
	document.getElementById('cometmarks_replace_newtitle').select();
	document.getElementById('cometmarks_replace_newtitle').focus();
}


function replace_onok()
{
	// get bookmark item id by cometmarks_guid
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var mainWindow = wm.getMostRecentWindow("navigator:browser");
	var replace_menu = mainWindow.document.getElementById("cometmarks_replace_menu");
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	var bookitem_id = bookmarksService.getItemIdForGUID(cometmarks_gdata.gCurrent_Tab_Guid);
	if (bookitem_id == -1)
	{
		replace_menu.setAttribute("disabled", true);
		document.getElementById("cometmarks_replace_panel").hidePopup();
		return;
	}
		
	// set new title and url
	var new_title = document.getElementById("cometmarks_replace_newtitle").value; // save it when changed first
	bookmarksService.setItemTitle(bookitem_id, new_title);
	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var new_url = document.getElementById("cometmarks_replace_newurl").value;
	var uri = ios.newURI(new_url, null, null);
	bookmarksService.changeBookmarkURI(bookitem_id, uri);
	write_log("=finish repalce title and url for old bookmark");
		
	// set replace button disabled
	replace_menu.setAttribute("disabled", true);
	document.getElementById("cometmarks_replace_panel").hidePopup();
}

function replace_oncancel()
{
	document.getElementById("cometmarks_replace_panel").hidePopup();	
}

function replace_key_enter(event)
{
	var evt = event || window.event;
	if (evt.keyCode == 13)// enter key
	{
		replace_onok();
	}
}

var notesObserver = 
{
	observe: function( subject, topic, data ) 
  {
  	if (topic == "cometmarks-notes-state")
			sync_notes_state( data );
  }
};

function sync_notes_state( data )
{
	if ( data == "close" )// close notes panel
	{
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel.state == "open" )// has opened
			cometmarks_note_panel_doclose(true);
	}
	
	if ( data == "disabled" )// let disabled
	{
		document.getElementById("cometmarks_button_note").setAttribute("image", "chrome://cometmarks/skin/state_not_login_16.png");
		document.getElementById("cometmarks_button_note").setAttribute("disabled", "true");
		
		document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "true");
		document.getElementById("cometmarks_show_note_menuitem").setAttribute("disabled", "true");
	}
}

window.addEventListener("load", On_load, false);
window.addEventListener("unload", Un_load, false);
