var node_array = new Array();
var fid_array = new Array();
var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
var cometmarks = Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension);

function create_element(doc, node_parent, tag, value)
{
	var elem = doc.createElement(tag);
	elem.textContent = value;
	node_parent.appendChild(elem);
	return elem;
}

function create_element_parent(doc, node_parent, tag)
{
	var elem = doc.createElement(tag);
	node_parent.appendChild(elem);
	return elem;
}

// bookmark_type = 1:toolbar, 2:menubar, 3:unfiledbar 0:other
function create_node(node_bookmarks, bookmark_type, node_parent, doc)
{
	var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
	var node = create_element_parent(doc, node_parent, "node");

	// only bookmark ,folder, separator not -1
	if (node_bookmarks.itemId != -1)
	{
		if (bookmark_type == 1)// toolbar
			create_element(doc, node, "guid", "BOOKMARK_TOOLBAR");
		else if (bookmark_type == 2)// menubar
			create_element(doc, node, "guid", "BOOKMARK_MENU");
		else if (bookmark_type == 3)// unfiledbar
			create_element(doc, node, "guid", "BOOKMARK_UNFILED");
		else// other
			create_element(doc, node, "guid", bookmarksService.getItemGUID(node_bookmarks.itemId));		
	}

	switch(node_bookmarks.type) 
	{
	case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_SEPARATOR:
		{
			create_element(doc, node, "type", "separator");
		}
		break;
	case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_URI:
		{
			create_element(doc, node, "type", 		"bookmark");
			create_element(doc, node, "name", 		node_bookmarks.title);
			// description
			create_element(doc, node, "keyword", 	bookmarksService.getKeywordForBookmark(node_bookmarks.itemId));
			create_element(doc, node, "tag", 		node_bookmarks.tags);
			create_element(doc, node, "url", 			node_bookmarks.uri);
			create_element(doc, node, "created", 	node_bookmarks.dateAdded);
			create_element(doc, node, "modified", node_bookmarks.lastModified);
			create_element(doc, node, "visited", 	node_bookmarks.accessCount);
		}
		break;
	case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_FOLDER:
		{
			var livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"]
			.getService(Components.interfaces.nsILivemarkService);
			var is_livemark = livemarkService.isLivemark(node_bookmarks.itemId);
			if (is_livemark)
			{
				create_element(doc, node, "type", 		"feed");
			}
			else
				create_element(doc, node, "type", 		"folder");
	
			create_element(doc, node, "name", 		node_bookmarks.title);
			// description
			create_element(doc, node, "keyword", 	bookmarksService.getKeywordForBookmark(node_bookmarks.itemId));
			create_element(doc, node, "tag", 		node_bookmarks.tags);
			
			if (is_livemark)
			{
				create_element(doc, node, "url", 			livemarkService.getSiteURI(node_bookmarks.itemId).spec);
				create_element(doc, node, "feedurl", livemarkService.getFeedURI(node_bookmarks.itemId).spec);	
			}
	
			create_element(doc, node, "created", 	node_bookmarks.dateAdded);
			create_element(doc, node, "modified", node_bookmarks.lastModified);
			create_element(doc, node, "visited", 	node_bookmarks.accessCount);
	
			node_bookmarks.QueryInterface(Components.interfaces.nsINavHistoryQueryResultNode);
			node_bookmarks.containerOpen = true;
	
			if (node_bookmarks.childCount != 0 && !is_livemark)
			{
				var children = create_element_parent(doc, node, "children");
				for (var i = 0; i < node_bookmarks.childCount; i++)
				{
					create_node(node_bookmarks.getChild(i), 0, children, doc);
				}
			}
	
			node_bookmarks.containerOpen = false;
		}
		break;
	case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_QUERY:
		{
			create_element(doc, node, "type", 		"query");
			create_element(doc, node, "name", 		node_bookmarks.title);
			// description
			create_element(doc, node, "keyword", 	bookmarksService.getKeywordForBookmark(node_bookmarks.itemId));
			create_element(doc, node, "tag", 		node_bookmarks.tags);
			create_element(doc, node, "url", 			node_bookmarks.uri);
			create_element(doc, node, "created", 	node_bookmarks.dateAdded);
			create_element(doc, node, "modified", node_bookmarks.lastModified);
			create_element(doc, node, "visited", 	node_bookmarks.accessCount);
		}
		break;

	default: break;
	}
}
	
function cometmarks_access_favorite()
{
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
  cometmarks_gdata.gBookmarks_Recovering = true; // prevent occuring onItemChanged event
	
	var xmldoc = document.implementation.createDocument("","",null);
	var head = xmldoc.createProcessingInstruction("xml","version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"");
	xmldoc.appendChild(head); 
	var nodest = xmldoc.createElement("nodeset");
	
	var historyService = Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService);
	var options = historyService.getNewQueryOptions();
	var query_toolbar = historyService.getNewQuery();
	var query_menubar = historyService.getNewQuery();
	var query_unfiledbar = historyService.getNewQuery();
	
	var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
	
	query_toolbar.setFolders([bookmarksService.toolbarFolder], 1);
	var result_toolbar = historyService.executeQuery(query_toolbar, options);
	var rootNode_toolbar = result_toolbar.root;	// toolbar node
	
	query_menubar.setFolders([bookmarksService.bookmarksMenuFolder], 1);
	var result_menubar = historyService.executeQuery(query_menubar, options);
	var rootNode_menubar = result_menubar.root;	// menubar node
	
	query_unfiledbar.setFolders([bookmarksService.unfiledBookmarksFolder], 1);
	var result_unfiledbar = historyService.executeQuery(query_unfiledbar, options);
	var rootNode_unfiledbar = result_unfiledbar.root;	// unfiledbar node
	
	var node = create_element_parent(xmldoc, nodest, "node");
	create_element(xmldoc, node, "guid", "ROOT");
	create_element(xmldoc, node, "type", "folder");
	
	var children = create_element_parent(xmldoc, node, "children");
	rootNode_toolbar.containerOpen = true;
	create_node(rootNode_toolbar, 1, children, xmldoc);
	rootNode_toolbar.containerOpen = false;
	
	rootNode_menubar.containerOpen = true;
	create_node(rootNode_menubar, 2, children, xmldoc);
	rootNode_menubar.containerOpen = false;
	
	rootNode_unfiledbar.containerOpen = true;
	create_node(rootNode_unfiledbar, 3, children, xmldoc);
	rootNode_unfiledbar.containerOpen = false;
	
	// add cometmarks notes
	create_note_xml(xmldoc, children);
	
	xmldoc.appendChild(nodest);

	//var serializer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer);
	//var xmlDeclaration = /^<\?xml version[^>]+?>/; 
	//var str = new XML( serializer.serializeToString(xmldoc).replace(xmlDeclaration, '') ).toXMLString();
	//str = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\" ?>\n" + str;
	
	var serializer = new XMLSerializer();
 	var str = serializer.serializeToString(xmldoc);
 	
	cometmarks_gdata.gBookmarks_Recovering = false;

	return str;
} 

function create_note_xml(doc, node_parent)
{
	// get notes data string
	var cometmarks_notes = cometmarks.GetCometMarksLocalNote();
	var local_notes = {};
	cometmarks_notes.GetLocalNotes( local_notes );
	var note_str = local_notes.value;
	
	if ( note_str.length == 0 )
		return;
		
	// add note parent
	var note_node = create_element_parent(doc, node_parent, "node");
	create_element(doc, note_node, "guid", "BOOKMARK_NOTES");
	create_element(doc, note_node, "type", "folder");
	create_element(doc, note_node, "name", "");
	create_element(doc, note_node, "keyword", "");
	create_element(doc, note_node, "tag", "");
	create_element(doc, note_node, "created", "");
	create_element(doc, note_node, "modified", "");
	create_element(doc, note_node, "visited", "");
	
	var note_children_node = create_element_parent( doc, note_node, "children" );

	// anlyze note: convert str to dom struct
  var parser = new DOMParser();
  var doc = parser.parseFromString( note_str, "text/xml");
     
  var noteset = doc.getElementsByTagName("noteset");
  var note_list = noteset[0].childNodes;
  for (var i=0; i<note_list.length; i++)
  {
    if ( note_list[i].nodeType == Node.ELEMENT_NODE)
    {
      var note_info = note_list[i].childNodes;
      var note_data = new Object();
         
      for (var j=0; j<note_info.length; j++)
      {
        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
        {
					note_data.guid = note_info[j].textContent;
        }

        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
        {
					note_data.type = note_info[j].textContent;
        }
        
        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
        {
					note_data.title = note_info[j].textContent;
        }

        if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
        {
					note_data.value = note_info[j].textContent;
        }
      }
      
			// add each note
			var children_node = create_element_parent(doc, note_children_node, "node" );
			create_element( doc, children_node, "guid", note_data.guid );
			create_element( doc, children_node, "type", note_data.type );
			create_element( doc, children_node, "name", note_data.title );
			create_element( doc, children_node, "content", note_data.value );
    }
  }
}

function cometmarks_syncnow()
{
	try
	{
		// to check overwrite dialog
		var overwrite_win = get_opened_dialog("CometMarksOverwriteDialog");
		if (overwrite_win)// has opened
		{
			overwrite_win.focus();
			return;
		}
		
		if (null == cometmarks )	
		{
			write_log( "cometmarks == null" );
			return;
		}
		
		var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
		var bookmarks_info = cometmarks.GetCometMarksInfo();	
		if (bookmarks_info.Loginned) // sync
		{
			write_log(cometmarks_gdata.gUserName + " has logined and begin to sync!");
			cometmarks_sync();
			return;
		}
	
		var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		var aUsername = cometmarks_gdata.gUserName;
		var aPassword = cometmarks_gdata.gPassword;

		if (aUsername == "" || aPassword == "")
		{
			var setting_win = get_opened_dialog("CometMarksSettingDialog");
			if (setting_win == null)// no exist the setting dialog
			{
				setting_win = window.open("chrome://cometmarks/content/cometmarks_setting.xul", "CometMarks Setting...", "chrome,titlebar,toolbar=no,centerscreen");				
				return;
			}
			
			setting_win.focus();		
			if ( aPassword == "" )
			{
				setting_win.document.getElementById("general_password_editbox").select();
				setting_win.document.getElementById("general_password_editbox").focus();
			}
			if ( aUsername == "" )
			{
				setting_win.document.getElementById("general_username_editbox").focus();
				setting_win.document.getElementById("general_username_editbox").select();
			}
			
			if (!bookmarks_info.Loginned)
				os.notifyObservers(null, "cometmarks-statechange", "COMETMARKS_NOTLOGIN");
			return;
		}
		else // set user name
		{
			write_log(aUsername + " not logined and begin to login");
			cometmarks_set_username(aUsername, aPassword);
		}
	}
	catch(e)
	{
	}
}

function format_GMT_time(gmt_time)
{
	if (gmt_time == "N/A")
		return "N/A";
	
	var time = new Date(gmt_time);
	var format_time = time.getFullYear() + "-";
	
	var month = time.getMonth() + 1;
	if (month < 10)
		format_time += "0";
	format_time = format_time + month.toString() + "-"; 
	
	var date = time.getDate();
	if (date < 10)
		format_time += "0";
	format_time = format_time + date.toString() + " ";
	
	var hour = time.getHours();
	if (hour < 10)
		format_time += "0";
	format_time = format_time + hour.toString() + ":"; 
	
	var minute = time.getMinutes();
	if (minute < 10)
		format_time += "0";
	format_time = format_time + minute.toString() + ":";

	var second = time.getSeconds();
	if (second < 10)
		format_time += "0";
	format_time = format_time + second.toString();
	 
	return format_time;
}


function get_time_sec(time_str)
{
	if (time_str == "N/A")
		return 0;

	var now = new Date(time_str);
	var seconds = now.getSeconds();
	seconds += now.getMinutes() * 60;
	return seconds;
}

function set_next_sync_time(interval_time)
{
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	
	// no login or logout
	if (interval_time == "N/A")
	{
		cometmarks_gdata.gNextSync_Time = "N/A";
		return;
	}
	
	var now = new Date();
	now.setSeconds( now.getSeconds() + interval_time );	
	
	cometmarks_gdata.gNextSync_Time = now.toGMTString();
	write_log("cometmarks next sync time: " + format_GMT_time(now));
}

function cometmarks_monitor_sync()
{
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	
	// no login or logout
	if (cometmarks_gdata.gNextSync_Time == "N/A")
		return;

	var now_time = new Date();
	var next_time = new Date(cometmarks_gdata.gNextSync_Time);
	if (now_time >= next_time)
	{
		cometmarks_gdata.gNextSync_Time = "N/A";
		cometmarks_sync();
	}
}

function cometmarks_timetick()
{
	cometmarks.CoreTimeTick();
}

function cometmarks_mybookmarks()
{
	var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
 	var url = bubble.GetStringFromName("cometmarks.atcomet.url");
 	
 	// get user name
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);       
	var prefs = ps.getBranch("cometmarks.");
	var user_name = prefs.getCharPref("username");
	
	url = url + "&u=" + utf8to16( user_name );
	open_url(url);
}

function open_url(url)
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var mainWindow = wm.getMostRecentWindow("navigator:browser");
	var gBrowser = mainWindow.getBrowser();
	
	var currentTab = gBrowser.getBrowserAtIndex(gBrowser.mTabContainer.selectedIndex);
	if (currentTab.currentURI.spec == "about:blank")// current tab
	{		
		gBrowser.loadURI(url, null, null);	
		return;
	}
	
  var browserEnumerator = wm.getEnumerator("navigator:browser");
  var browserWin = browserEnumerator.getNext();
  var tabbrowser = browserWin.getBrowser();

	var index = tabbrowser.browsers.length - 1;
  var lastBrowser = tabbrowser.getBrowserAtIndex(index);
  if (lastBrowser.currentURI.spec == "about:blank")
  {
   tabbrowser.selectedTab = tabbrowser.mTabs[index];	
   gBrowser.loadURI(url, null, null);
  }
  else
  {	
   tabbrowser.selectedTab = gBrowser.addTab(url, null, null);
  }
}

function cometmarks_set_username(sUsername, sPassword)
{
	if (null == cometmarks )	
	{
		write_log( "cometmarks == null" );
		return;
	}

	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	var bookmarks_info = cometmarks.GetCometMarksInfo();
	
	write_log("cometmarks begin to set username!");
	cometmarks.SetUserName(sUsername, sPassword);
	write_log("cometmarks end to set username!");
	
	if (bookmarks_info.Loginned)
	{
		cometmarks_sync();
		return;
	}
	
	cometmarks_login();// if no login, to login now
}

function cometmarks_login()
{
	if (null == cometmarks )	
	{
		write_log( "cometmarks == null" );
		return;
	}
		
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	cometmarks_gdata.gBookmarks_Status = "COMETMARKS_SYNCING";
	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	os.notifyObservers(null, "cometmarks-statechange", "COMETMARKS_SYNCING");
	
	write_log("cometmarks begin to login!");
	cometmarks.LogIn();// wait for update call back
	write_log("cometmarks end to login!");
}

function cometmarks_sync()
{
	try
	{
		if (null == cometmarks )	
		{
			write_log( "cometmarks == null" );
			return;
		}
		
		// if no accout has login, don't sync 
		var bookmarks_info = cometmarks.GetCometMarksInfo();
		if (!bookmarks_info.Loginned)
			return;
		
		var str = cometmarks_access_favorite();
		var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
		cometmarks_gdata.gBookmarks_Status = "COMETMARKS_SYNCING";
		var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		os.notifyObservers(null, "cometmarks-statechange", "COMETMARKS_SYNCING");
		
		write_log("cometmarks begin to sync!");
		cometmarks.Sync( str );
		write_log("cometmarks end to sync!");
	}
	catch (e)
	{
		write_log(e);
	}
}

function cometmarks_commit()
{
	if (null == cometmarks )	
	{
		write_log( "cometmarks == null" );
		return;
	}
		
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	cometmarks_gdata.gBookmarks_Changed = true;
	
	write_log("cometmarks begin to commit!");
	var str = cometmarks_access_favorite();
	cometmarks.Commit( str );
	write_log("cometmarks end to commit!");
}

function cometmarks_merge()
{
	if (null == cometmarks )	
	{
		write_log( "cometmarks == null" );
		return;
	}
		
	write_log("cometmarks begin to merge!");
	var str = cometmarks_access_favorite();				
	cometmarks.CometmarksMerge( str );						
	cometmarks_merge_special();
	cometmarks_recover();
	
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	cometmarks_gdata.gBookmarks_Status = "COMETMARKS_CHANGED";
	var minimum_sync_interval_sec = get_minimum_sync_interval_sec();
	cometmarks_gdata.gBookmarks_Changed = true;
	var now = new Date();
	cometmarks_gdata.gLastSync_Time = now.toGMTString();
	set_next_sync_time(minimum_sync_interval_sec);
	
	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	os.notifyObservers(null, "cometmarks-statechange", "COMETMARKS_CHANGED");
	write_log("cometmarks end to merge!");
}

function cometmarks_merge_special()
{
	if (null == cometmarks )	
	{
		write_log( "cometmarks == null" );
		return;
	}
		
	var str = cometmarks_access_favorite();
	cometmarks.MergeSpecial( str );
}

function cometmarks_setting()
{
	var setting_win = get_opened_dialog("CometMarksSettingDialog");
	if (setting_win == null || setting_win.closed)
		setting_win = window.open("chrome://cometmarks/content/cometmarks_setting.xul", "CometMarks Setting...", "chrome,titlebar,toolbar,centerscreen");	
	else
		setting_win.focus();
}

function get_password(username)
{
	var password = "";
	var hostname = "http://my.atcomet.com"; 
	var formSubmitURL = null; 
	var httprealm = "cometmarks";
	
	if (username == "")
		return password;
		
	try 
	{
	   // Get Login Manager 
	   var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
		  
	   // Find users for the given parameters
	   var logins = myLoginManager.findLogins({}, hostname, formSubmitURL, httprealm);
	      
	   // Find user from returned array of nsILoginInfo objects
	   for (var i = 0; i < logins.length; i++) 
	   {
	      if (logins[i].username == username) 
	      {
	         password = logins[i].password;
	         break;
	      }
	   }
	}
	catch(ex) 
	{
	   write_log(ex);
	}
	
	return password;
}

function add_accout(username, password)
{
	var hostname = "http://my.atcomet.com";
	var formSubmitURL = null; 
	var httprealm = "cometmarks";
	
 	if (username == "")
    return;
    
   // to check if in loginManager
   var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);

	 var logins = myLoginManager.findLogins({}, hostname, formSubmitURL, httprealm);
	 var old_password;
	 var has_username = false;   
	 for (var i = 0; i < logins.length; i++) 
	 {
	  if (logins[i].username == username) 
	  {
	   old_password = logins[i].password;
	   has_username = true;
	   break;
	  }
	}
	
	var lm = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
	var nsli = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Components.interfaces.nsILoginInfo, "init");
	var newli = new nsli(hostname, formSubmitURL, httprealm, username, password, "", "");
	if (has_username)// is old username
	{
		var oldli = new nsli(hostname, formSubmitURL, httprealm, username, old_password, "", "");
		if (password.length == 0)// delete old password
		{		
			lm.removeLogin(oldli);
		}
		else
		{
			lm.modifyLogin(oldli, newli);
		}
	}
  else // add new accout
  {   
	  if(password.length > 0)
	  {
			lm.addLogin(newli);
			write_log("save accout: " + username);
		}
  }
}

function utf16to8(str) 
{
  var out, i, len, c;

  out = "";
  len = str.length;
  for(i = 0; i < len; i++) 
  {
	 c = str.charCodeAt(i);
		if ((c >= 0x0001) && (c <= 0x007F)) 
		{
		  out += str.charAt(i);
		} 
		else if (c > 0x07FF) 
		{
			out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
			out += String.fromCharCode(0x80 | ((c >>  6) & 0x3F));
			out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
		} 
	 	else 
		{
			out += String.fromCharCode(0xC0 | ((c >>  6) & 0x1F));
			out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
		}
  }
  return out;
}

function utf8to16(str) 
{
  var out, i, len, c;
  var char2, char3;

  out = "";
  len = str.length;
  i = 0;
  while(i < len) 
  {
		c = str.charCodeAt(i++);
		switch(c >> 4)
		{
		  case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7:
		    // 0xxxxxxx
		    out += str.charAt(i-1);
		    break;
		  case 12: case 13:
		    // 110x xxxx   10xx xxxx
		    char2 = str.charCodeAt(i++);
		    out += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
		    break;
		  case 14:
		    // 1110 xxxx  10xx xxxx  10xx xxxx
		    char2 = str.charCodeAt(i++);
		    char3 = str.charCodeAt(i++);
		    out += String.fromCharCode(((c & 0x0F) << 12) |
		        ((char2 & 0x3F) << 6) |
		        ((char3 & 0x3F) << 0));
		    break;
		}
  }

  return out;
}

function get_opened_dialog(winType)
{
	var windowsMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var setting_win = windowsMediator.getMostRecentWindow(winType);
	return setting_win;
}

function cometmarks_overwrite_dialog_show()
{	
	window.openDialog('chrome://cometmarks/content/cometmarks_overwrite_dialog.xul','','resizable=no,modal');
}

		
function cometmarks_recover()
{
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	cometmarks_gdata.gBookmarks_Recovering = true;// begin to recover

	bookmarksService.removeFolderChildren(bookmarksService.toolbarFolder);
	bookmarksService.removeFolderChildren(bookmarksService.bookmarksMenuFolder);
	bookmarksService.removeFolderChildren(bookmarksService.unfiledBookmarksFolder);
	
	while (node_array.length > 0)
		node_array.shift();	
		
	while (fid_array.length > 0)
		fid_array.shift();
	
	// get bookmarks nodes from bookmarksmxl into node_array
	get_bookmarksnode_from_bookmarksxml();

	// begin to draw bookmarks from node_array's nodes
	var recover = new comet_recover();
	recover.ensurePlacesDefaultQueriesInitialized();
	cometmarks_gdata.gBookmarks_Changed = false;
}

		
function comet_recover()
{
}

comet_recover.prototype = 
{
	ensurePlacesDefaultQueriesInitialized: function() 
	{	
		var callback = 
		{		  
				runBatched: function()
				{
					var node = null;
					var fid = null;
					while (node_array.length > 0)
					{					
						node = node_array.shift();
						if (node.guid == "BOOKMARK_TOOLBAR" || node.guid == "BOOKMARK_MENU" || node.guid == "BOOKMARK_UNFILED")
							continue;
							
						if (node.pguid == "BOOKMARK_TOOLBAR")
							fid = bookmarksService.toolbarFolder;
						else if (node.pguid == "BOOKMARK_MENU")
							fid = bookmarksService.bookmarksMenuFolder;
						else if (node.pguid == "BOOKMARK_UNFILED")
							fid = bookmarksService.unfiledBookmarksFolder;
						else
						{
							for (var i=0; i<fid_array.length; i++)
							{
								if(node.pguid == fid_array[i].guid)
								{
									fid = fid_array[i].fid;
									break;
								}
							}
						}
		
						if (fid == null)
							continue;
						fid = draw(node, fid);// draw bookmark here
							
						var node_fid = new Object();
						node_fid.guid = node.guid;
						node_fid.fid = fid;
						fid_array.push(node_fid);
				}
			}
		}
		
		try
		{
      bookmarksService.runInBatchMode( callback, null );   
    } 
    catch(e) 
    { 
    	write_log(e); 
    }
   },
}

// node struct
function comet_node(pguid, guid, name, type, url, feedurl, keyword, 
							created, modified, visited, icon, description, tag, children)
{
	this.pguid = pguid;
	this.guid = guid;
	this.type = type;
	this.url = url;
	this.feedurl = feedurl;
	this.name = name;
	this.description = description;
	this.keyword = keyword;
	this.tag = tag;
	this.created = created;
	this.modified = modified;
	this.visited = visited;
	this.icon = icon;
	this.children = children;
}

function get_bookmarksnode_from_bookmarksxml()
{
	var bookmarks_info = cometmarks.GetCometMarksInfo();
	var content = bookmarks_info.Bookmarks_Content;
	if (content == "")
		return;
	
	// convert str to dom struct
	var parser = new DOMParser();
	var doc = parser.parseFromString(content, "text/xml");
		
	var nodeset = doc.getElementsByTagName("nodeset");
	var node_list = nodeset[0].childNodes;
	for (var m=0; m<node_list.length; m++)
	{
		if (node_list[m].nodeType == Node.ELEMENT_NODE)
		{
			var node = node_list[m].childNodes;
			for (var i=0; i<node.length; i++)
			{
				if (node[i].nodeType == Node.ELEMENT_NODE && node[i].tagName == "children")
				{
					var bookmark_node = node[i].childNodes;
							
					for (var n=0; n<bookmark_node.length; n++)
					{
						if (bookmark_node[n].nodeType == Node.ELEMENT_NODE)
						{
							var guid = "";
							var name = "";
							var url = "";
							var feedurl = "";
							var keyword = "";
							var created = "";
							var modified = "";
							var tag = "";
							var type = "";
							var children = "";
							var icon = "";
							var description = "";
							var visited = "";

							var toolbar_node = bookmark_node[n].childNodes;
							for (var j=0; j<toolbar_node.length; j++)
							{
								if (toolbar_node[j].nodeType == Node.ELEMENT_NODE)
								{										
									if (toolbar_node[j].tagName == "guid")
										guid = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "name")
										name = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "type")
										type = toolbar_node[j].textContent;	
									else if (toolbar_node[j].tagName == "url")
										url = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "feedurl")
										feedurl = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "keyword")
										keyword = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "created")
										created = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "modified")
										modified = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "visited")
										visited = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "icon")
										icon = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "description")
										description = toolbar_node[j].textContent;// the description value is not used in bookmarks
									else if (toolbar_node[j].tagName == "tag")
										tag = toolbar_node[j].textContent;
									else if (toolbar_node[j].tagName == "children")
										children = toolbar_node[j].childNodes;
								}
							}
							if (type == "folder" && guid == "BOOKMARK_TOOLBAR")// bookmark_toolbar
							{				
								var bookmark_toolbar_node = new comet_node(null, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children);
								node_array.push(bookmark_toolbar_node);
								if (children != "" && children.length != 0)
									save_bookmarks_node(bookmark_toolbar_node, children);				
							}
							
							if (type == "folder" && guid == "BOOKMARK_MENU")// bookmark_menu
							{				
								var bookmark_menu_node = new comet_node(null, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children);
								node_array.push(bookmark_menu_node);
								if (children != "" && children.length != 0)
									save_bookmarks_node(bookmark_menu_node, children);		
							}
							
							if (type == "folder" && guid == "BOOKMARK_UNFILED")// bookmark_unfiled
							{				
								var bookmark_unfiled_node = new comet_node(null, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children);
								node_array.push(bookmark_unfiled_node);
								if (children != "" && children.length != 0)
									save_bookmarks_node(bookmark_unfiled_node, children);		
							}
							
							if (type == "folder" && guid == "BOOKMARK_NOTES")// BOOKMARK_NOTES
							{				
								if (children != "" && children.length != 0)
								{
									// create local note xml
								  var xmldoc = document.implementation.createDocument("","",null);
								  var head = xmldoc.createProcessingInstruction("xml","version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"");
								  xmldoc.appendChild(head);
								  var noteset = xmldoc.createElement("noteset");
								  
									for (var k=0; k<children.length; k++) // note nodes
									{										
										if (children[k].nodeType == Node.ELEMENT_NODE)
										{										
											var node_children = children[k].childNodes;
											var note_data = new Object();
											
											for (var t=0; t<node_children.length; t++)
											{		
												if (node_children[t].nodeType == Node.ELEMENT_NODE && node_children[t].tagName == "guid")
												{
													note_data.guid = node_children[t].textContent;
												}
												
												if (node_children[t].nodeType == Node.ELEMENT_NODE && node_children[t].tagName == "type")
												{
													note_data.type = node_children[t].textContent;
												}
												
												if (node_children[t].nodeType == Node.ELEMENT_NODE && node_children[t].tagName == "name")
												{
													note_data.title = node_children[t].textContent;
												}
													
												if (node_children[t].nodeType == Node.ELEMENT_NODE && node_children[t].tagName == "content")
												{
													note_data.value = node_children[t].textContent;
												}
											}
											
											// create new note element
									    var note = create_element_parent(xmldoc, noteset, "note");
									    create_element(xmldoc, note, "guid", note_data.guid );
									    create_element(xmldoc, note, "type", note_data.type );
									    create_element(xmldoc, note, "name", note_data.title );
									    create_element(xmldoc, note, "content", note_data.value );
										}
									}
									
									xmldoc.appendChild(noteset);
									
									var serializer = new XMLSerializer();
								 	var str = serializer.serializeToString(xmldoc);

									// set local notes
								  //write_note_toxml( str );
								}								
							}
							
						}//node
							
					}//for
						
				}
			}
		}
	}
}

function save_bookmarks_node(node, node_list)
{		 	
  try
  {	
		for (var k=0; k<node_list.length; k++)
		{
			if (node_list[k].nodeType == Node.ELEMENT_NODE)
			{					
				var guid = "";
				var name = "";
				var url = "";
				var feedurl = "";
				var keyword = "";
				var created = "";
				var modified = "";
				var visited = "";
				var tag = "";
				var type = "";
				var children = "";
				var icon = "";
				var description = "";
				
				var node_children = node_list[k].childNodes;
				for (var i=0; i<node_children.length; i++)
				{			
					if (node_children[i].nodeType == Node.ELEMENT_NODE)
					{
						if (node_children[i].tagName == "guid")
							guid = node_children[i].textContent;
						else if (node_children[i].tagName == "name")
							name = node_children[i].textContent;
						else if (node_children[i].tagName == "type")
							type = node_children[i].textContent;	
						else if (node_children[i].tagName == "url")
							url = node_children[i].textContent;
						else if (node_children[i].tagName == "feedurl")
							feedurl = node_children[i].textContent;
						else if (node_children[i].tagName == "keyword")
							keyword = node_children[i].textContent;
						else if (node_children[i].tagName == "created")
							created = node_children[i].textContent;
						else if (node_children[i].tagName == "modified")
							modified = node_children[i].textContent;
						else if (node_children[i].tagName == "visited")
							visited = node_children[i].textContent;
						else if (node_children[i].tagName == "icon")
							icon = node_children[i].textContent;
						else if (node_children[i].tagName == "description")
							description = node_children[i].textContent;
						else if (node_children[i].tagName == "tag")
							tag = node_children[i].textContent;
						else if (node_children[i].tagName == "children")
							children = node_children[i].childNodes;
					}
				}
				
				var child_node = new comet_node(node.guid, guid, name, type, url, feedurl, 
															keyword, created, modified, visited, icon, description, tag, children);
				node_array.push(child_node);

				if (children != "" && children.length != 0)// save its children
				{
					save_bookmarks_node(child_node, child_node.children);
				}
			}
		}
	}
	catch(e)
	{
		write_log(e);
	}
}


function draw(node, fid)
{
		if (node.type == "separator")
		{
			try
			{
				var separatorId = bookmarksService.insertSeparator(fid, -1);
				if (separatorId)
					bookmarksService.setItemGUID(separatorId, node.guid);
				return separatorId;
			}
			catch(e)
			{
				write_log(e);
			}
		}
		else if(node.type == "query")
		{
			if (node.url == "" || node.url.length == 0)
				return null;
				
			try
			{
				var bookmarkURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(node.url, null, null);
				var bookmarkId = bookmarksService.insertBookmark(fid, bookmarkURI, -1, node.name);
			
				bookmarksService.setItemGUID(bookmarkId, node.guid);
				bookmarksService.setKeywordForBookmark(bookmarkId, node.keyword);
				bookmarksService.setItemDateAdded(bookmarkId, node.created);
				bookmarksService.setItemLastModified(bookmarkId, node.modified);
				return bookmarkId;
			}
			catch(e)
			{
				write_log(e);
			}
		}
		else if(node.type == "feed")
		{
			if (node.url == "" || node.feedurl == "")
				return null;
				
			try
			{
				var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			
				var siteURI = IOService.newURI(node.url, null, null);
				var feedURI = IOService.newURI(node.feedurl, null, null);
			
				var livemarks = Components.classes["@mozilla.org/browser/livemark-service;2"].getService(Components.interfaces.nsILivemarkService);
			
				var livemarksId = livemarks.createLivemark(fid, node.name, siteURI, feedURI, -1);
				bookmarksService.setItemGUID(livemarksId, node.guid);
				return livemarksId;
			}
			catch(e)
			{
				write_log(e);
			}
		}
		else if (node.type == "bookmark") 
		{
			if (node.url == "" || node.url.length == 0)
				return null;
				
			var bookmarkURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(node.url, null, null);
			
			try
			{	
				var bookmarkId = bookmarksService.insertBookmark(fid, bookmarkURI, -1, node.name);
				if (bookmarkId)
				{
					bookmarksService.setItemGUID(bookmarkId, node.guid);
					bookmarksService.setKeywordForBookmark(bookmarkId, node.keyword);
					bookmarksService.setItemDateAdded(bookmarkId, node.created);
					bookmarksService.setItemLastModified(bookmarkId, node.modified);
				}
				return bookmarkId;
			}
			catch(e)
			{
				write_log(e);
			}
		}
		else if (node.type == "folder")
		{
			try
			{
				var folderId = bookmarksService.createFolder(fid, node.name, -1);
				if (folderId)
					bookmarksService.setItemGUID(folderId, node.guid);
				return folderId;
			}
			catch(e)
			{
				write_log(e);
			}
		}
}

function set_autosync_interval_sec(time_seconds)
{
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);       
	var prefs = ps.getBranch("cometmarks.");
	prefs.setIntPref("autosync_interval_sec", time_seconds);
}

function get_autosync_interval_sec()
{
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);       
	var prefs = ps.getBranch("cometmarks.");
	var	time_seconds = prefs.getIntPref("autosync_interval_sec");
  	
	return time_seconds;
}

function set_minimum_sync_interval_sec(time_seconds)
{
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);       
	var prefs = ps.getBranch("cometmarks.");
	prefs.setIntPref("minimum_sync_interval_sec", time_seconds);
}

function get_minimum_sync_interval_sec()
{
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);       
	var prefs = ps.getBranch("cometmarks.");
	var time_seconds = prefs.getIntPref("minimum_sync_interval_sec");
  
	return time_seconds;
}

// when the bookmark change, it will notify the browser, and update it
var bookmark_listener = 
{
	onBeginUpdateBatch: function() 
	{
	},
  
	onEndUpdateBatch: function() 
	{
		var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
		cometmarks_gdata.gBookmarks_Recovering = false;// finish recovering
		this._inBatch = false;
	},
  
	onItemAdded: function(aItemId, aFolder, aIndex) 
	{
		interval_sync_update(aItemId);
	},
  
	onItemRemoved: function(aItemId, aFolder, aIndex) 
	{
		// let replace menu disabled	  	
		var replace_menu = document.getElementById("cometmarks_replace_menu");
		replace_menu.setAttribute("disabled", true);
	},
  
	onItemVisited: function(aBookmarkId, aVisitID, time) 
	{
	},
  
	onItemMoved: function(aItemId, aOldParent, aOldIndex, aNewParent, aNewIndex) 
	{
		interval_sync_update(aItemId);
	},
  
	onItemChanged: function(aBookmarkId, aProperty, aIsAnnotationProperty, aValue) 
	{
		interval_sync_update(aBookmarkId);
	},
  
	QueryInterface: function(iid) 
	{
		if (iid.equals(Components.interfaces.nsINavBookmarkObserver) || iid.equals(Components.interfaces.nsISupports)) 
		{
		  return this;
		}
		throw Components.results.NS_ERROR_NO_INTERFACE;
	}
};


function begin_bookmark_listener()
{
	var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
	bookmarksService.addObserver(bookmark_listener, false);
}

 
function end_bookmark_listener()
{
	var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
	if (bookmark_listener != null && bookmark_listener != undefined)
		bookmarksService.removeObserver(bookmark_listener);
}

// when the bookmark change, commit it interval one minute
function interval_sync_update(aBookmarkId)
{ 			
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	var bookmarks_info = cometmarks.GetCometMarksInfo();
	
	if (!bookmarks_info.Loginned)// no accout has login, ignore it
		return;
		
	if (cometmarks_gdata.gBookmarks_Recovering)// if bookmarks recovering, ignore it // on batching
		return;
		
	if ( is_feed_node(aBookmarkId) )// the bookmark is feed or in feed place, ignore
		return;
	
	cometmarks_gdata.gBookmarks_Changed = true;
	var now = new Date();
	var change_time_sec = get_time_sec(now.toGMTString());
	var lastsync_time_sec = get_time_sec(cometmarks_gdata.gLastSync_Time);
	
	var sync_time = 3;
	if (change_time_sec < lastsync_time_sec)
		change_time_sec += 3600;
		
	var offset = change_time_sec - lastsync_time_sec;
	var minimum_sync_interval_sec = get_minimum_sync_interval_sec();// get from pref.js, and default is 1 * 60
	if (offset > minimum_sync_interval_sec - 1 || offset < 4) // more than minimum_sync_interval_sec or less than 4
		sync_time = 3;
	else  // between 4 and minimum_sync_interval_sec
		sync_time = minimum_sync_interval_sec - offset;
		
	set_next_sync_time(sync_time);
	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	os.notifyObservers(null, "cometmarks-statechange", "COMETMARKS_CHANGED");
	cometmarks_gdata.gBookmarks_Status = "COMETMARKS_CHANGED";
}

function is_feed_node(aBookmarkId)
{
	if (aBookmarkId == null)
		return false;
		
	var livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"].getService(Components.interfaces.nsILivemarkService);
	var is_livemark = livemarkService.isLivemark(aBookmarkId);
	if (is_livemark)// is feed or in feed place
	{
		return true;
	}
	
	if (aBookmarkId == bookmarksService.placesRoot)// normal node
	{
		return false;
	}
		
	var pfolder = bookmarksService.getFolderIdForItem(aBookmarkId);
  return is_feed_node(pfolder);
}

function cometmarks_show_error_message()
{
	// show error message
  var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
 	var message = bubble.GetStringFromName("cometmarks.operate.failed");
  alert (message);
}

function clear_accout_data()
{
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	
	write_log(cometmarks_gdata.gUserName + " has logout and clear its data!");
	add_accout(cometmarks_gdata.gUserName, "");
	cometmarks_gdata.gUserName = "";
	cometmarks_gdata.gPassword = "";
	
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var prefs = ps.getBranch("cometmarks.");
	prefs.setCharPref("username", "");
}

function show_menubar_state(type)
{
	// set note button diabled when logout
	var cometmarks_show_note_menuitem = document.getElementById("cometmarks_show_note_menuitem");
	var cometmarks_show_note_statebar = document.getElementById("cometmarks_show_note_statebar");
	var cometmarks_show_note_toolbarbutton = document.getElementById("cometmarks_button_note");
	var cometmarks_showstatusicon_menuitem = document.getElementById("cometmarks_showstatusicon_menuitem");
	var cometmarks_showstatusicon_status = document.getElementById("cometmarks_showstatusicon_status");
	
	if (type == "login")
	{
		if( document.getElementById("toggle_taskbar").getAttribute("checked") == "true" )
		{
			cometmarks_show_note_toolbarbutton.setAttribute("disabled", "false");
			cometmarks_show_note_toolbarbutton.setAttribute("image", "chrome://cometmarks/skin/logo_16.png");
			
			cometmarks_show_note_menuitem.setAttribute("disabled", "false");
			cometmarks_show_note_statebar.setAttribute("disabled", "false");
			cometmarks_showstatusicon_menuitem.setAttribute("disabled", "false");
			cometmarks_showstatusicon_status.setAttribute("disabled", "false");
		}
		else
		{
			cometmarks_show_note_toolbarbutton.setAttribute("image", "chrome://cometmarks/skin/state_not_login_16.png");
			cometmarks_show_note_toolbarbutton.setAttribute("disabled", "true");
			
			cometmarks_show_note_menuitem.setAttribute("disabled", "true");
			cometmarks_show_note_statebar.setAttribute("disabled", "true");
			cometmarks_showstatusicon_menuitem.setAttribute("disabled", "true");
			cometmarks_showstatusicon_status.setAttribute("disabled", "true");
		}
	}
	else
	{
		cometmarks_show_note_toolbarbutton.setAttribute("image", "chrome://cometmarks/skin/state_not_login_16.png");
		cometmarks_show_note_toolbarbutton.setAttribute("disabled", "true");		
		cometmarks_show_note_menuitem.setAttribute("disabled", "true");
		cometmarks_show_note_statebar.setAttribute("disabled", "true");
	}
 		
	// get local language
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefs = ps.getBranch("general.");
	var locate_name = prefs.getCharPref("useragent.locale");
	if (locate_name != "en-US" && locate_name != "zh-CN")
		return;
  	
	var menu = document.getElementById("bookmarksMenu");
	var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
	if (type == "login")
		menu.setAttribute("label", bubble.GetStringFromName("cometmarks.online_login.book"));
	else
		menu.setAttribute("label", bubble.GetStringFromName("cometmarks.online_logout.book"));		
}

function cometmarks_check_replace()
{
	// init status
	var replace_menu = document.getElementById("cometmarks_replace_menu");
	replace_menu.setAttribute("disabled", true);			
	var cometmarks_gdata = cometmarks.GetCometMarksGlobalData();
	cometmarks_gdata.gCurrent_Tab_Guid = null;
		
	try
	{	
		var cometmarks_guid = null;
		var currentTab = gBrowser.getBrowserAtIndex(gBrowser.mTabContainer.selectedIndex);
		
		// check current url
		if (currentTab.currentURI.spec == "about:blank" || currentTab.currentURI.host == null || currentTab.currentURI.host.length == 0)
		{
			return;
		}
		
		if ( bookmarksService.isBookmarked(currentTab.currentURI) )
		{
			return; 
		}
		
		cometmarks_guid = currentTab.getAttribute("cometmarks_guid");
		// cometmarks_guid is null or invalid
		if (cometmarks_guid == null || cometmarks_guid.length == 0)
		{
			currentTab.setAttribute("cometmarks_guid", null);
			return;
		}	
    
		// the bookmarks with cometmarks_guid is delete before
		var bookitem_id = bookmarksService.getItemIdForGUID(cometmarks_guid);
		if (bookitem_id == -1)
		{
			currentTab.setAttribute("cometmarks_guid", null);
			return;
		}
  	
		// url is the same with original_url
		var original_uri = bookmarksService.getBookmarkURI(bookitem_id); 
		if (currentTab.currentURI.spec == original_uri.spec)
		{
			return;
		}
			
		// now replace menu can used
		cometmarks_gdata.gCurrent_Tab_Guid = cometmarks_guid;
		replace_menu.setAttribute("disabled", false);
	}
	catch (e)
	{
		write_log(e);
	}
}

// deal with uninstall extension
var Extension_UninstallObserver = 
{
	_uninstall : false,

	observe : function(subject, topic, data)
	{
		if (topic == "em-action-requested")
		{ 
			subject.QueryInterface(Components.interfaces.nsIUpdateItem);
			if(subject.id == "bookmarks@cometmarks.com")
			{
				if (data == "item-uninstalled")
				{
					this._uninstall = true;
				}
				
				if (data == "item-cancel-action")
				{
					this._uninstall = false;
				}
			}
		}
		else if (topic == "quit-application-granted")
		{
			if (this._uninstall)
			{
				// clean the data of extension
				cometmarks.CleanTempData();
				delete_log();
						
				// clean the data of cometmarks extension in prefs.js		
				var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);      
				var prefs = ps.getBranch("cometmarks.");
				prefs.deleteBranch("");// delete all value of cometmarks	
			}
			
			this.unregister();
		}
	 },
	 
	register : function()
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  	observerService.addObserver(this, "em-action-requested", false);
  	observerService.addObserver(this, "quit-application-granted", false);
 	},
 	
 	unregister : function()
 	{
  	var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  	observerService.removeObserver(this,"em-action-requested");
  	observerService.removeObserver(this,"quit-application-granted");
 	}
}

// set cometmarks_guid if the loading url is bookmark
var urlBarListener = 
{
	QueryInterface: function(aIID)
	{
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		   aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		   aIID.equals(Components.interfaces.nsISupports))
			return this;
		throw Components.results.NS_NOINTERFACE;
	},
	
	onLocationChange: function(aProgress, aRequest, aURI)
	{
		if ( !bookmarksService.isBookmarked(aURI) )
			return; 
			
		var BookmarkId_array = bookmarksService.getBookmarkIdsForURI(aURI, {});			
		var cometmarks_guid = bookmarksService.getItemGUID(BookmarkId_array[0]); // first one
		
		var currentTab = gBrowser.getBrowserAtIndex(gBrowser.mTabContainer.selectedIndex); 					 	
		currentTab.setAttribute("cometmarks_guid", cometmarks_guid);// set guid for current tab
	},
	
	onStateChange: function() {},
	onProgressChange: function() {},
	onStatusChange: function() {},
	onSecurityChange: function() {},
	onLinkIconAvailable: function() {}
};

function cometmarks_get_server_notes()
{
	var bookmarks_info = cometmarks.GetCometMarksInfo();
	var bookmarks_content = bookmarks_info.Bookmarks_Content;
	if (bookmarks_content == "")
		return "";
	
	var parser = new DOMParser();
	var xmlDoc = parser.parseFromString(bookmarks_content, "text/xml");
		
	var oEvaluator = new XPathEvaluator();
	var sXPath = "/nodeset/node/children/node/guid";
	var oResult = oEvaluator.evaluate(sXPath, xmlDoc.documentElement, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
	if (oResult == null)// don't find cometmarks note node
		return "";

	var elem_note = null;
	var oElement_note;
	var is_notes_exist = false;
	while (oElement_note = oResult.iterateNext()) 
	{
		if (oElement_note.textContent == "BOOKMARK_NOTES")
		{
			elem_note = oElement_note.parentNode;
			is_notes_exist = true;
			break;
		}
	}
	
	if ( !is_notes_exist )
		return "";
		
	sXPath = "./children/node";
	oResult = oEvaluator.evaluate(sXPath, elem_note, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
	if (oResult == null) // don't find note's content
		return "";
	
	// create local note xml
	var xmldoc = document.implementation.createDocument("","",null);
	var head = xmldoc.createProcessingInstruction("xml","version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"");
	xmldoc.appendChild(head);
	var noteset = xmldoc.createElement("noteset");	
	
	var oElement;
	while (oElement = oResult.iterateNext())// save all notes into files
	{	
		var note_info = oElement.childNodes;	
	  var note_data = new Object();
	  	
	  for (var j=0; j<note_info.length; j++)
	  {
	    if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
	    {
				note_data.guid = note_info[j].textContent;
	    }
	
	    if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
	    {
				note_data.type = note_info[j].textContent;
	    }
	    
	    if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
	    {
				note_data.title = note_info[j].textContent;
	    }
	
	    if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
	    {
				note_data.value = note_info[j].textContent;
	    }
	  }
	      
	// save notes from xml
	var note = create_element_parent(xmldoc, noteset, "note");
	create_element(xmldoc, note, "guid", note_data.guid );
	create_element(xmldoc, note, "type", note_data.type );
	create_element(xmldoc, note, "name", note_data.title );
	create_element(xmldoc, note, "content", note_data.value );
	}
	
	xmldoc.appendChild(noteset);
	
	var serializer = new XMLSerializer();
	var notes_xml_str = serializer.serializeToString(xmldoc);
	
	return notes_xml_str;
}

function cometmarks_create_guid()
{
	var guid = "";
	for (var i = 1; i <= 32; i++)
	{
		var n = Math.floor(Math.random()*16.0).toString(16);
		guid += n;
		if((i==8)||(i==12)||(i==16)||(i==20))
		guid += "-";
	}
	return guid;    
}